---
title: 水泵远程检测平台
sidebar_position: 2
---

# 介绍
水泵远程质量检测与质量比对系统实现以下功能：
* 实现水泵运行参数采集功能；
* 实现水泵检测现场监控功能；
* 实现审查机构水泵检测过程回溯功能；
* 实现终端数据远程传输功能；
* 实现质量比对相关远程存储、查询、统计、分析等功能。

## 目标
  利用工业物联网、移动通信、网络技术、智能传感、电子证据链、数据爬取等技术完成水泵远程质量检测取证，实现水泵质量关键数据的采集与传输；借助第三方可信公证云平台的认证，确保检测取证过程合法合规；通过水泵远程检测取证工具矩阵的数据与检测结果数据的比对，保障检测过程的规范性、真实性与有效性。利用大数据分析、科学计算、分布式存储、分布式计算、可视化等技术完成水泵远程质量检测质量比对，通过对不同地区、厂家、类型、批次、指标等多个维度数据分析比对，实现对水泵质量数据的大数据分；借助与相关行业标准、技术规范的比对，确保将对水泵质量比对的数据进行全面科学分析。通过对生产企业水泵质量数据的分析应用，可为质检中心水泵产业整合与行业升级的决策提供支撑。
## 范围
  以水泵远程检测取证场切入点，此产品主要围绕水泵远程检测数据采集、采集任务管理、质检数据比对分析等功能作基础设计与研发，完成对水泵检测取证过程配套硬件设备的选型与调测；项目架构时需要考虑平台后期发展的可扩展性。
### 水泵质量远程检测
  线上完成水泵检测任务的流转，及时任务分配与提示，加速质检任务的发布执行与质检结果的发布；依托线上取证平台充分整合行业检测资源，科学利用水泵行业整体质量检测能力，将质检认证资质授权至质检能力合格企业，有效缓解水泵企业质量检测能力发展不均衡、质检中心检测任务过重、行业质检资源未充分利用等问题。
提供便携式水泵质量比对现场采集套件与云端质量比对数据分析系统；通过现场采集套件与云端服务、计算资源协同工作，完成质检远程取证业务流、数据流双流合一的闭环管理，逐步实现水泵质量检测远程取证的规范化、标准化、制度化。
### 水泵质量比对系统
 完成水泵质量核心指标数据建模，运用虚拟化技术构建测试仪表数字化模型，利用云端服务实现测试仪表质量检测结果可视化呈现；为二次检测设备厂商提供“互联网+”质量问题诊断服务，提升行业整体数字化、信息化水平；结合水泵质量数据多维度对比分析，为水泵企业提升产品质量提供综合诊断与质量提升引导服务，为监管单位进行产业整合提供全面数据支撑。
逐步扩展成以水泵检测综合服务为核心的综合服务平台，实现远程取证服务、行业交流服务、质检综合管理、质量检测数据分析、数据运营“五位一体”的总体布局；加强水泵企业共享质检中心、共享水泵检测实验室、二次检测设备厂商、行业专家的线上交流与互动；利用电子商务技术提供线上水泵检测服务交易平台，提高质检资源的综合利用率，实现行业质检资源的综合利用与动态调控。

# 组态设计

## 背景元素
  
## 物模型控件

## 取证控件

### 文件标识

### 图片证据
evidence/image/{evidenceid}.jpg
如果{evidenceid} 为 5d00e37b7b
则完整的图片证据文件数据编码为 evidence/image/5d00e37b7b.jpg

### 视频证据
evidence/video/{evidenceid}.mp4
如果{evidenceid} 为 5d00e37b7b
则完整的视频证据文件数据编码为 evidence/video/5d00e37b7b.mp4

### 音频证据
evidence/audio/{evidenceid}.mp3
如果{evidenceid} 为 5d00e37b7b
则完整的视频证据文件数据编码为 evidence/audio/5d00e37b7b.wav

### 文件证据
evidence/file/{evidenceid}.doc
如果{evidenceid} 为 5d00e37b7b
则完整的视频证据文件数据编码为 evidence/file/5d00e37b7b.doc
#### 数据结构
payload 
```json
{
    "data": "\"M21 6h-7.59l3.29-3.29L16 2l-4 4-4-4-.71.71L10.59 6H3c-1.1 0-2 .89-2 2v12c0 1.1.9 2 2 2h18c1.1 0 2-.9 2-2V8c0-1.11-.9-2-2-2zm0 14H3V8h18v12zM9 10v8l7-4z\"", // svg图标
    "evidenceList": "[]", // 证据列表 传文件名 详见文件标识
    "draggable": "true", // 拖拽
    "fill": "\"grey\"", // 颜色 grey表示取证阶段，yellow表示审核阶段，green标识审核通过，red标识审核不过
    "handler": "\"dblclick\"", // 功能触发事件
    "icon": "\"live_tv\"", // 取证图标 && 控件类型
    "id": "\"16408c5903_evidence_18_live_tv\"", 
    "type": "video", // 证据类型 ['video','audio','image','file'] 视频 音频 图片 文档
    "name": "\"evidence\"", // 事件类型
    "scaleX": "2", // 放大倍数
    "scaleY": "2", // 放大倍数
    "x": "133", // x坐标轴
    "y": "612", // y坐标轴
}
```

## 功能事件
### 功能事件触发条件 
通过``payload.handler``触发取证事件。通过``EventBus`` 加上``payload.fill``类型去判断取证审核逻辑，下发``EventBus``管理``dgiotServer``事件 

## 图片元素
## 取证fill控件颜色标识
样式里面：灰色表示取证阶段，黄色表示审核阶段，绿色标识审核通过，红色标识审核不过
### 基于组态的质检取证查证需求
组态取证涉及到相关点，质检报告号，测试台体号，质检项（位置信息），组态控件（样式（位置信息，背景颜色，文字等），数据（产品类型），行为（弹窗/跳转））。具体如下：
#### 质检项位置
    
![质检项位置](https://dgiot-1253666439.cos.ap-shanghai-fsi.myqcloud.com/shuwa_tech/zh/manual/cloud/pumpTest/%E8%B4%A8%E6%A3%80%E9%A1%B9%E4%BD%8D%E7%BD%AE)

#### 取证动作
![取证动作](https://dgiot-1253666439.cos.ap-shanghai-fsi.myqcloud.com/shuwa_tech/zh/manual/cloud/pumpTest/%E5%8F%96%E8%AF%81%E5%8A%A8%E4%BD%9C)

#### 逻辑推导关系：
					
|报告|质检项|位置|控件号|控件类型|样式|数据|行为|业务逻辑|
|-|-|-|-|-|-|-|-|-|-|
|{deviceid}|页面区域|{x，y}|控件id|图片	|灰色	|平板	|双击	|拍照|
|{deviceid}|页面区域|{x，y}|控件id|音频	|灰色	|平板	|双击	|录音|
|{deviceid}|页面区域|{x，y}|控件id|视频	|灰色	|平板	|双击	|录像|
|{deviceid}|页面区域|{x，y}|控件id|材料	|灰色	|平板	|双击	|传文件|
|{deviceid}|页面区域|{x，y}|控件id|图片	|黄色	|平板	|双击	|显示图片|
|{deviceid}|页面区域|{x，y}|控件id|音频	|黄色	|平板	|双击	|播放录音|
|{deviceid}|页面区域|{x，y}|控件id|视频	|黄色	|平板	|双击	|播放录像|
|{deviceid}|页面区域|{x，y}|控件id|材料	|黄色	|平板	|双击	|看文件|
|{deviceid}|页面区域|{x，y}|控件id|图片	|绿色	|平板	|双击	|显示图片|
|{deviceid}|页面区域|{x，y}|控件id|音频	|绿色	|平板	|双击	|播放录音|
|{deviceid}|页面区域|{x，y}|控件id|视频	|绿色	|平板	|双击	|播放录像|
|{deviceid}|页面区域|{x，y}|控件id|材料	|绿色	|平板	|双击	|看文件|
|{deviceid}|页面区域|{x，y}|控件id|图片	|红色	|平板	|双击	|显示图片|
|{deviceid}|页面区域|{x，y}|控件id|音频	|红色	|平板	|双击	|播放录音|
|{deviceid}|页面区域|{x，y}|控件id|视频	|红色	|平板	|双击	|播放录像|
|{deviceid}|页面区域|{x，y}|控件id|材料	|红色	|平板	|双击	|看文件|

## 四 采集opc数据
### 读取opc属性
topic: /{ProductId}/{DevAddr}/device/event
方向: 下行
开始任务
消息格式:
```
{
"cmd":"opc_items", // 增加items
"groupid":"设备ID",
"opcserver":"Kepware.KEPServerEX.V6", //opcserver路径
"items":["GCU331_YJ.Q_Q_DN65","GCU331_YJ.SX_PZ96_U_55","GCU331_YJ.SX_PZ96_P_55","GCU331_YJ.SX_PZ96_I_55","GCU331_YJ.p_L_1","GCU331_YJ.p_Q_1"] //要读取到属性列表
}
```
采集数据
消息格式:
```
{
"cmd":"opc_report", //
"duration":5, //采集条数
"groupid":"设备ID"
}
```

### opc属性上报
topic: /{ProductId}/{DevAddr}/report/opc/properties
方向: 上行
消息格式:
```
{
"timestamp":1601196762389, //毫秒时间戳
"deviceId":"设备ID",
"properties":{"GCU331_YJ.p_L_1":36.8,"GCU331_YJ.SX_PZ96_U_55":220} //上报数据
}
```

### 组态上报
topic: topo/{ProductId}/{DevAddr}/post
方向: 上行
消息格式:
```
{
"timestamp":1601196762389, //毫秒时间戳
"thingdata":{"flow":36.8,"vol":220} //组态数据
}
```

### 低代码标识
+ 测试项标识
dgiot_testing_equipment_ 标识符开头，
例如流量的标识符为dgiot_testing_equipment_flow
低代码里面配置的参数为：

**View中存储的数据结构**
```
name:流量计：
id: "dgiot_testing_equipment_flow"
value: {name: "流量计1”,id："GCU331_YJ.p_L_1"},
range:
[
  {name: "流量计1”,id："GCU331_YJ.p_L_1"}，
  {name: "流量计2",id："GCU331_YJ.p_L_2"}，
]
```
**Device:basedata存储的数据结构**
```
{
  "dgiot_testing_equipment_flow":"GCU331_YJ.p_L_1"
}
```
+ 测试项采样参数
dgiot_sampling_parametric 标识符开头，例如
**采样时长**
**View中存储的数据结构**
```
name:采集条数：
id: "dgiot_sampling_parametric_duration"
value: 1,
Unit: 条
```
**Device:basedata存储的数据结构**
```
{
  "dgiot_sampling_parametric_duration":"1"
}
```

# 报告生成

## 一 新建产品模板
### 1，报告模板标签介绍
#### 标签是word里需要替换的文本，不同文本标签不能重复 现阶段三种标签
- 文本标签: **{{var}}**
例：{{reportid}}
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637806208_KQ166gQJ.png)
- 图片标签以@开始：**{{@var}}** 
例：{{@performance_curve}}
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637806190_oc6j6k1T.png)
- 动态表格标签：**{{var}}** 
- 标签放在表格内的任意单元格内
- 动态表格要选择第几行第几列
例：{{dynamicTable}} 从第二行开始 有八列
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637806159_v5i49858.png)

### 2，创建产品模板字典
#### 字典对应报告模板里标签
- 标题填选  worddict
- 类型选 word
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637806824_blLCvL3L.png)
- 设计，新增，根据报告模板标签，**标识符**与**模板标签**括号内一致
- 数据来源选择
数据来源于**物模型**选择**thing**
来源于**低代码**选择**amis**
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637831490_V344XfgP.png)

- 类型选择 
- 文本选 text 
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637807196_lUhIv2Ud.png)
- 图片选 image
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637807817_K2bBHe3L.png)
- 动态表单选择 dynamicTable 例如 从第二行开始 有八列
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637812542_GGlL5fD7.png)

### 1，创建低代码页面
#### 低代码页面配置作用填写文本数据
- 配置低代码页面
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637805822_kx30hx46.png)

## 二 添加报告模板
- 选择创建的产品模板
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637813655_vPLfb753.png)
- 选取写好的报告模板
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637813800_vy2kgyYN.png)
- 模板管理，绘图
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637813920_DmOF0oE0.png)
- 给每一页模板添加，需要的取证按钮，保存
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637814134_Q2e76Z5Y.png)

## 三 添加检测任务
- 选择报告模板，测试台体，创建
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637814303_NebA2e2X.png)
- 任务配置
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637814527_gzwlk28l.png)
- 填写 配置的低代码页面数据
![image.png](https://ww.iotn2n.com/attachment/attachment/images/2021/11/25/image_1637814548_NqPP61uz.png)

